unit Test;
{
QueryInfo Component Pack v0.94 preview testbed
by Justin Turberville
EMail: justint@cyberjoe.co.za

I use this project and test dialog for developing the QueryInfo component
pack and have included it as it is usefull for sampling the components
without first having to install them as they are manually created and set.
Experiment with their properties in FormCreate below as I have done.
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DBTables, DB, StdCtrls, ExtCtrls, Buttons, ComCtrls,
  qiField, qiFldsEd, qiTblsEd, qiJnsEd, qiQuery, qiFormat, qiFilter,
  qiLookup, qiOrder, qiClrsEd, qiSelect, qiGroup, MemoDlg, qiArchiv,
  qiWdw, qiFrBldr, qiUpdate, qiModify, qiDefine, qiAutGrp, qiTables;

type
  TTestForm = class(TForm)
    Orders: TTable;
    Customers: TTable;
    CustomersCustNo: TFloatField;
    CustomersCompany: TStringField;
    CustomersAddr1: TStringField;
    CustomersAddr2: TStringField;
    CustomersCity: TStringField;
    CustomersState: TStringField;
    CustomersZip: TStringField;
    CustomersCountry: TStringField;
    CustomersPhone: TStringField;
    CustomersFAX: TStringField;
    CustomersTaxRate: TFloatField;
    CustomersContact: TStringField;
    CustomersLastInvoiceDate: TDateTimeField;
    OrdersOrderNo: TFloatField;
    OrdersCustNo: TFloatField;
    OrdersSaleDate: TDateTimeField;
    OrdersShipDate: TDateTimeField;
    OrdersEmpNo: TIntegerField;
    OrdersShipToContact: TStringField;
    OrdersShipToAddr1: TStringField;
    OrdersShipToAddr2: TStringField;
    OrdersShipToCity: TStringField;
    OrdersShipToState: TStringField;
    OrdersShipToZip: TStringField;
    OrdersShipToCountry: TStringField;
    OrdersShipToPhone: TStringField;
    OrdersShipVIA: TStringField;
    OrdersPO: TStringField;
    OrdersTerms: TStringField;
    OrdersPaymentMethod: TStringField;
    OrdersItemsTotal: TCurrencyField;
    OrdersTaxRate: TFloatField;
    OrdersFreight: TCurrencyField;
    OrdersAmountPaid: TCurrencyField;
    TestPages: TPageControl;
    QuerySheet: TTabSheet;
    UpdateSheet: TTabSheet;
    Label2: TLabel;
    SQLQueryMemo: TMemo;
    Label3: TLabel;
    UserQueryMemo: TMemo;
    SelectBtn: TButton;
    GroupBtn: TButton;
    OrderBtn: TButton;
    ExecuteBtn: TButton;
    Label1: TLabel;
    SQLUpdateMemo: TMemo;
    Label4: TLabel;
    UserUpdateMemo: TMemo;
    UpdateBtn: TButton;
    ApplyBtn: TButton;
    QueryFilterBtn: TButton;
    UpdateFilterBtn: TButton;
    KindRadios: TRadioGroup;
    UpdateQuery: TQuery;
    LookupBtn: TButton;
    FindNextBtn: TButton;
    LoadBtn: TButton;
    StoreBtn: TButton;
    DefineBtn: TButton;
    QueryEditBtn: TButton;
    UpdateEditBtn: TButton;
    OptionsSheet: TTabSheet;
    EditorsGroup: TGroupBox;
    TablesBtn: TButton;
    FieldsBtn: TButton;
    JoinsBtn: TButton;
    CloseBtn: TButton;
    SortFieldsCheck: TCheckBox;
    ShowGlyphsCheck: TCheckBox;
    TableNamesCheck: TCheckBox;
    FilterBldrCheck: TCheckBox;
    ShowHintsCheck: TCheckBox;
    MultiColumnCheck: TCheckBox;
    KeepOpenCheck: TCheckBox;
    AboutSheet: TTabSheet;
    Label6: TLabel;
    Bevel1: TBevel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Memo1: TMemo;
    GroupDlgCheck: TCheckBox;
    BrowseCheck: TCheckBox;
    DefaultSelectCheck: TCheckBox;
    Image1: TImage;
    ColorsBtn: TButton;
    Label5: TLabel;
    Label11: TLabel;
    PickTablesBtn: TButton;
    SelectedOnlyCheck: TCheckBox;
    HelpBtn: TButton;
    FontBtn: TButton;
    FontDlg: TFontDialog;
    Employees: TTable;
    EmployeesEmpNo: TIntegerField;
    EmployeesLastName: TStringField;
    EmployeesFirstName: TStringField;
    EmployeesPhoneExt: TStringField;
    EmployeesHireDate: TDateTimeField;
    EmployeesSalary: TFloatField;
    procedure FormCreate(Sender: TObject);
    procedure QueryFilterBtnClick(Sender: TObject);
    procedure LookupBtnClick(Sender: TObject);
    procedure OrderBtnClick(Sender: TObject);
    procedure SelectBtnClick(Sender: TObject);
    procedure ExecuteBtnClick(Sender: TObject);
    procedure GroupBtnClick(Sender: TObject);
    procedure EditBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure StoreBtnClick(Sender: TObject);
    procedure FindNextBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TablesBtnClick(Sender: TObject);
    procedure FieldsBtnClick(Sender: TObject);
    procedure JoinsBtnClick(Sender: TObject);
    procedure UpdateBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure UpdateFilterBtnClick(Sender: TObject);
    procedure KindRadiosClick(Sender: TObject);
    procedure DefineBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure SortFieldsCheckClick(Sender: TObject);
    procedure ShowGlyphsCheckClick(Sender: TObject);
    procedure TableNamesCheckClick(Sender: TObject);
    procedure ShowHintsCheckClick(Sender: TObject);
    procedure DefaultSelectCheckClick(Sender: TObject);
    procedure MultiColumnCheckClick(Sender: TObject);
    procedure KeepOpenCheckClick(Sender: TObject);
    procedure BrowseCheckClick(Sender: TObject);
    procedure ColorsBtnClick(Sender: TObject);
    procedure PickTablesBtnClick(Sender: TObject);
    procedure SelectedOnlyCheckClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FontBtnClick(Sender: TObject);
  private
    FieldInfo:  TQIFieldInfo;
    QueryInfo:  TQIQueryInfo;
    Formatter:  TQIFormatter;
    SelectDlg:  TQISelectDialog;
    FilterDlg:  TQIFilterDialog;
    LookupDlg:  TQILookupDialog;
    OrderDlg:   TQIOrderDialog;
    GroupDlg:   TQIGroupDialog;
    AutoGrpDlg: TQIAutoGroupDialog;
    EditDlg:    TMemoDialog;
    QueryWdw:   TQIQueryWindow;
    Archiver:   TQIArchiver;
    FilterBldr: TQIFilterBuilder;
    UpdateInfo: TQIUpdateInfo;
    ModifyDlg:  TQIModifyDialog;
    DefineDlg:  TQIDefineDialog;
    TablesDlg:  TQITablesDialog;
    procedure QueryInfoChange(Sender: TObject);
    procedure UpdateInfoChange(Sender: TObject);
    procedure OpenQuery(Sender: TObject);
    procedure CloseQuery(Sender: TObject);
    procedure CheckTable(Sender: TObject; DB, T: string; var Veto: Boolean);
    procedure CheckJoin(Sender: TObject; DB, T1, F1, T2, F2: string;
      var veto: Boolean);
    procedure ForceBridgingJoins;
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.FormCreate(Sender: TObject);
begin
  {Manually create & set QI components so they don't have to be installed
   first - their units must just be in the same directory as this program}

  {Initialize FieldInfo}
  FieldInfo := TQIFieldInfo.Create(Self);
  with FieldInfo do begin
    DatabaseName := 'DBDEMOS';
    AutoJoin := False;        {quicker to add join manually! -see later on}
    Tables.AddFromTable(Customers);     {add tables from TTables -}
    Tables.AddFromTable(Orders);
    AutoJoin := True;
    with Fields do begin                 {add table fields from TFields -}
      AddFromField(CustomersCustNo).UserName := 'Customer#';
      AddFromField(CustomersCompany);
      AddFromField(CustomersAddr1).UserName := 'Address';
      AddFromField(CustomersCity);
      AddFromField(OrdersOrderNo).UserName := 'Order#';
      AddFromField(OrdersEmpNo).UserName := 'Employee#';
      AddFromField(OrdersCustNo).Usage := [];
      AddFromField(OrdersAmountPaid);
(*    AddFrom('Paid', '', 'ORDERS.AmountPaid > 0',  {see QueryInfo.Definitions below}
        Tables.ByTableRef(Orders), ftBoolean, [fuSelect..fuLookup], nil);*)
      AddFrom('Commission', '', {'ORDERS.AmountPaid * 0.125'}'', {see Definitions}
        Tables.ByTableRef(Orders), ftCurrency, nil, [fuSelect..fuLookup]);
      AddFromField(OrdersPaymentMethod);
      AddFromField(OrdersSaleDate);
      Joins.AddFrom(                       {manually add join}
        ByFieldRef(CustomersCustNo), ByFieldRef(OrdersCustNo), qoEquals);
    end;
  end;

  {Initialize QueryInfo}
  QueryInfo := TQIQueryInfo.Create(Self);
  with QueryInfo do begin
    FieldInfo := Self.FieldInfo;
    with Definitions do begin      {add user-editable calculated field-}
      with AddNew do begin
        Field := Fields.BySQLName('Commission');
        AddFieldElement(Fields.BySQLName('AmountPaid'));
        AddOperatorElement(coMultiply);
        AddValueElement('0.125');
      end;
      UpdateFormulas(True);   {update calculated fields' CalcFormula properties}
    end;
    OnChange := QueryInfoChange;
  end;

  {Initialize UpdateInfo}
  UpdateInfo := TQIUpdateInfo.Create(Self);
  with UpdateInfo do begin
    FieldInfo := Self.FieldInfo;
    OnChange := UpdateInfoChange;
  end;

  {Initialize Formatter}
  Formatter := TQIFormatter.Create(Self);
  with Formatter do begin
    QueryInfo := Self.QueryInfo;
    UpdateInfo := Self.UpdateInfo;
  { DefaultSelect := True;}
  end;

  {Initialize ModifyDialog}
  ModifyDlg := TQIModifyDialog.Create(Self);
  with ModifyDlg do begin
    UpdateInfo := Self.UpdateInfo;
{   Aggregates := Aggregates - [qaAve];}
  end;

  {Initialize DefineDlg}
  DefineDlg := TQIDefineDialog.Create(Self);
  with DefineDlg do begin
    QueryInfo := Self.QueryInfo;
{   Aggregates := Aggregates - [qaAve];}
  end;

  {Initialize SelectDlg}
  SelectDlg := TQISelectDialog.Create(Self);
  with SelectDlg do begin
    QueryInfo := Self.QueryInfo;
{   Aggregates := Aggregates - [qaAve];}
  end;

  {Initialize FilterDlg}
  FilterDlg := TQIFilterDialog.Create(Self);
  with FilterDlg do begin
    QueryInfo := Self.QueryInfo;
    UpdateInfo := Self.UpdateInfo;
{   Operators := Operators - [qoLike];}
  end;

  {Initialize OrderDlg}
  OrderDlg := TQIOrderDialog.Create(Self);
  OrderDlg.QueryInfo := Self.QueryInfo;

  {Initialize GroupDlg}
  GroupDlg := TQIGroupDialog.Create(Self);
  GroupDlg.QueryInfo := Self.QueryInfo;

  {Initialize AutoGrpDlg}
  AutoGrpDlg := TQIAutoGroupDialog.Create(Self);
  AutoGrpDlg.QueryInfo := Self.QueryInfo;

  {Initialize MemoDlg}
  EditDlg := TMemoDialog.Create(Self);
  EditDlg.Caption := 'SQL Script Editor';

  {Initialize QueryWdw}
  QueryWdw := TQIQueryWindow.Create(Self);
  with QueryWdw do begin
    QueryInfo := Self.QueryInfo;
    RequestLive := False;
{   with TitleFont do begin
      Name := 'Arial';
      Color := clGrey;
      Style := [fsBold];
    end;}
    OnOpenQuery := Self.OpenQuery;
    OnCloseQuery := Self.CloseQuery;
{   OnLoadBtn := LoadBtnClick;         {allow QueryWdw to handle edits -
    OnSaveBtn := StoreBtnClick;
    OnBrowseBtn := BrowseBtnClick;
    OnDefineBtn := DefineBtnClick;
    OnSelectBtn := SelectBtnClick;
    OnFilterBtn := QueryFilterBtnClick;
    OnOrderBtn  := OrderBtnClick;
    OnEditBtn := EditBtnClick;
    OnLookupBtn := LookupBtnClick;
    OnFindNextBtn := FindNextBtnClick;
    OnHelpBtn := HelpBtnClick}
  end;

  {Initialize LookupDlg}
  LookupDlg := TQILookupDialog.Create(Self);
  with LookupDlg do begin
    QueryInfo := Self.QueryInfo;
    DataSource := QueryWdw.QuerySource;
  end;

  {Initialize Archiver}
  Archiver := TQIArchiver.Create(Self);
  with Archiver do begin
    QueryInfo := Self.QueryInfo;
    KeepOpen := True;
    Browse := False;
    StoreFields := True;
    LoadCaption := 'Load Query Script';
  end;

  {Initialize FilterBldr}
  FilterBldr := TQIFilterBuilder.Create(Self);
  with FilterBldr do begin
    QueryInfo := Self.QueryInfo;
    Colors.BkgndColor := clCream;
  end;

  {Initialize TablesDlg}
  TablesDlg := TQITablesDialog.Create(Self);
  with TablesDlg do begin
    FieldInfo := Self.FieldInfo;
    BrowseAliases := False;    {only user allow acces to 'DBDEMOS' database}
    OnListTable := CheckTable;      {restrict tables listed}
    OnAddJoin := CheckJoin;         {only allow intended joins}
  end;

  {Initialize TestForm}
  QueryInfoChange(nil);
  TestPages.ActivePage := AboutSheet;
end;

procedure TTestForm.FormDestroy(Sender: TObject);
begin
  Formatter.Free;
  DefineDlg.Free;
  SelectDlg.Free;
  FilterDlg.Free;
  LookupDlg.Free;
  OrderDlg.Free;
  GroupDlg.Free;
  AutoGrpDlg.Free;
  EditDlg.Free;
  QueryWdw.Free;
  Archiver.Free;
  FilterBldr.Free;
  ModifyDlg.Free;
  TablesDlg.Free;
  QueryInfo.Free;
  UpdateInfo.Free;
  FieldInfo.Free;
end;

{Note that the following three procedures invoke what are really
 design time only property editors - eg. EditFields invokes the Fields
 property editor. A runtime editor itself should call ChangeNotify if
 the edit is applied, passing the list that was edited. See ChangeNotify
 in qiField.hlp & qiQuery.hlp}

procedure TTestForm.TablesBtnClick(Sender: TObject);
begin
  if EditTables(FieldInfo) then
    FieldInfo.ChangeNotify(Self, FieldInfo.Tables);
end;

procedure TTestForm.FieldsBtnClick(Sender: TObject);
begin
  if EditFields(FieldInfo) then
    FieldInfo.ChangeNotify(Self, FieldInfo.Fields);
end;

procedure TTestForm.JoinsBtnClick(Sender: TObject);
begin
  if EditJoins(FieldInfo) then
    FieldInfo.ChangeNotify(Self, FieldInfo.Joins);
end;

{query handlers}

procedure TTestForm.DefineBtnClick(Sender: TObject);
begin
  DefineDlg.Execute;
end;

procedure TTestForm.SelectBtnClick(Sender: TObject);
begin
  SelectDlg.Execute;
end;

procedure TTestForm.QueryFilterBtnClick(Sender: TObject);
begin
  if FilterBldrCheck.Checked then
    FilterBldr.Execute else           {an alternative to FilterDlg}
    FilterDlg.Execute(fkQuery);
end;

procedure TTestForm.OrderBtnClick(Sender: TObject);
begin
  OrderDlg.Execute;
end;

procedure TTestForm.GroupBtnClick(Sender: TObject);
begin
  if GroupDlgCheck.Checked then
    GroupDlg.Execute else
    AutoGrpDlg.Execute;
end;

procedure TTestForm.EditBtnClick(Sender: TObject);
begin
  if TestPages.ActivePage = QuerySheet then
    EditDlg.Execute(SQLQueryMemo.Lines) else
    EditDlg.Execute(SQLUpdateMemo.Lines);
end;

procedure TTestForm.LookupBtnClick(Sender: TObject);
begin
  with LookupDlg do begin
    if Execute and LookupFirst then begin
      QueryWdw.Show;
      FindNextBtn.Enabled := True;
    end;
  end;
end;

procedure TTestForm.FindNextBtnClick(Sender: TObject);
begin
  FindNextBtn.Enabled := LookupDlg.LookupNext;
  if FindNextBtn.Enabled then
    QueryWdw.Show;
end;

procedure TTestForm.LoadBtnClick(Sender: TObject);
begin
  Archiver.Load;
end;

procedure TTestForm.StoreBtnClick(Sender: TObject);
begin
  Archiver.Store(QueryInfo.QueryTitle, UserQueryMemo.Lines);
end;

procedure TTestForm.ExecuteBtnClick(Sender: TObject);
begin
  with QueryWdw do begin
    SQLScript.Assign(SQLQueryMemo.Lines);
{   DisplayScript.Assign(UserQueryMemo.Lines);} {this shows the script in a pane}
    if QueryInfo.QueryTitle <> '' then
      Caption := QueryInfo.QueryTitle else
      Caption := 'Query Result';
    OpenQuery;
  end;
end;

procedure TTestForm.QueryInfoChange(Sender: TObject);
begin
  if QueryInfo.Tables.Count > 2 then     {if more of the allowed DBDEMOS tables}
    ForceBridgingJoins;                  {are included, this could be required }
  Formatter.SQLQueryScript(SQLQueryMemo.Lines);     {rebuild scripts -}
  Formatter.UserQueryScript(UserQueryMemo.Lines);
  ExecuteBtn.Enabled := SQLQueryMemo.Lines.Count > 0;
  QueryFilterBtn.Enabled := ExecuteBtn.Enabled;
  GroupBtn.Enabled := ExecuteBtn.Enabled;
  OrderBtn.Enabled := ExecuteBtn.Enabled;
  QueryEditBtn.Enabled := ExecuteBtn.Enabled;
end;

procedure TTestForm.OpenQuery(Sender: TObject);
begin
  LookupBtn.Enabled := True;
end;

procedure TTestForm.CloseQuery(Sender: TObject);
begin
  LookupBtn.Enabled := False;
  FindNextBtn.Enabled := False;
end;

{update handlers}

procedure TTestForm.UpdateInfoChange(Sender: TObject);
begin
  Formatter.SQLUpdateScript(SQLUpdateMemo.Lines);
  Formatter.UserUpdateScript(UserUpdateMemo.Lines);
  ApplyBtn.Enabled := SQLUpdateMemo.Lines.Count > 0;
  UpdateFilterBtn.Enabled := ApplyBtn.Enabled and
    (TUpdateKind(KindRadios.ItemIndex) <> ukInsert);
  UpdateEditBtn.Enabled := ApplyBtn.Enabled;
end;

procedure TTestForm.UpdateBtnClick(Sender: TObject);
begin
  ModifyDlg.Execute;
end;

procedure TTestForm.UpdateFilterBtnClick(Sender: TObject);
begin
  FilterDlg.Execute(fkUpdate);
end;

procedure TTestForm.ApplyBtnClick(Sender: TObject);
var
  s: string;
begin
  if (TUpdateKind(KindRadios.ItemIndex) = ukModify) and
     (UpdateInfo.Filters.Count = 0) then         {warn if no filtering -}
    if MessageDlg('All records will be modified as there is no filtering',
      mtWarning, [mbOK, mbCancel], 0) <> mrOK then Exit;
  if TUpdateKind(KindRadios.ItemIndex) = ukDelete then begin  {confirm delete -}
    if UpdateInfo.Filters.Count = 0 then
      s := 'ALL' else
      s := 'filtered';
    if MessageDlg('Deleting ' + s + ' records in ' +
      UpdateInfo.UpdateTable.UserName + ' !!!', mtWarning,
      [mbOK, mbCancel], 0) <> mrOK then Exit;
  end;
  UpdateQuery.SQL.Assign(SQLUpdateMemo.Lines);
  UpdateQuery.ExecSQL;
  MessageDlg('Update successfully completed!', mtInformation, [mbOK], 0);
end;

procedure TTestForm.KindRadiosClick(Sender: TObject);
begin
  UpdateInfo.UpdateKind := TUpdateKind(KindRadios.ItemIndex);
  UpdateInfoChange(nil);
end;

{options handlers}

procedure TTestForm.CloseBtnClick(Sender: TObject);
begin
  if MessageDlg('Terminate this program?', mtConfirmation, [mbOK, mbCancel], 0)
    = mrOK then Close;
end;

procedure TTestForm.SortFieldsCheckClick(Sender: TObject);
begin
  with SortFieldsCheck do begin
    DefineDlg.SortFields := Checked;
    SelectDlg.SortFields := Checked;
    FilterDlg.SortFields := Checked;
    GroupDlg.SortFields  := Checked;
    OrderDlg.SortFields  := Checked;
    ModifyDlg.SortFields := Checked;
    LookupDlg.SortFields := Checked;
    FilterBldr.SortFields := Checked;
    TablesDlg.SortTables := Checked;
  end;
end;

procedure TTestForm.ShowGlyphsCheckClick(Sender: TObject);
begin
  with ShowGlyphsCheck do begin
    DefineDlg.ShowGlyphs  := Checked;
    SelectDlg.ShowGlyphs  := Checked;
    FilterDlg.ShowGlyphs  := Checked;
    GroupDlg.ShowGlyphs   := Checked;
    AutoGrpDlg.ShowGlyphs := Checked;
    OrderDlg.ShowGlyphs   := Checked;
    ModifyDlg.ShowGlyphs  := Checked;
    LookupDlg.ShowGlyphs  := Checked;
    FilterBldr.ShowGlyphs := Checked;
    Archiver.ShowGlyphs   := Checked;
    TablesDlg.ShowGlyphs  := Checked;
    EditDlg.BorBtns       := Checked;
  end;
end;

procedure TTestForm.TableNamesCheckClick(Sender: TObject);
begin
  with TableNamesCheck do begin
    SelectDlg.AddTableName  := Checked;
    FilterDlg.AddTableName  := Checked;
    FilterBldr.AddTableName := Checked;
    GroupDlg.AddTableName   := Checked;
    AutoGrpDlg.AddTableName := Checked;
    OrderDlg.AddTableName   := Checked;
    DefineDlg.AddTableName  := Checked;
    LookupDlg.AddTableName  := Checked;
    QueryWdw.AddTableName   := Checked;
    Formatter.AddTableName  := Checked;
  end;
  QueryInfoChange(nil);
  UpdateInfoChange(nil);
end;

procedure TTestForm.ShowHintsCheckClick(Sender: TObject);
begin
  with ShowHintsCheck do begin
    Self.ShowHint := Checked;
    DefineDlg.ShowHints := Checked;
    SelectDlg.ShowHints := Checked;
    FilterDlg.ShowHints := Checked;
    OrderDlg.ShowHints  := Checked;
    QueryWdw.ShowHints  := Checked;
  end;
end;

procedure TTestForm.DefaultSelectCheckClick(Sender: TObject);
begin
  Formatter.DefaultSelect := DefaultSelectCheck.Checked;
  QueryInfoChange(nil);   {update scripts}
end;

procedure TTestForm.SelectedOnlyCheckClick(Sender: TObject);
begin
  with SelectedOnlyCheck do begin
    FilterDlg.SelectedOnly := Checked;
    GroupDlg.SelectedOnly := Checked;
    OrderDlg.SelectedOnly := Checked;
  end;
end;

procedure TTestForm.MultiColumnCheckClick(Sender: TObject);
begin
  LookupDlg.MultiColumn := MultiColumnCheck.Checked;
end;

procedure TTestForm.KeepOpenCheckClick(Sender: TObject);
begin
  Archiver.KeepOpen := KeepOpenCheck.Checked;
end;

procedure TTestForm.BrowseCheckClick(Sender: TObject);
begin
  Archiver.Browse := BrowseCheck.Checked;
end;

procedure TTestForm.ColorsBtnClick(Sender: TObject);
begin
  with TFilterColorsForm.Create(Self) do
  try                                            {invoke FilterBldr's Colors }
    Colors := FilterBldr.Colors;                 {property design-time editor}
    ShowModal;
  finally
    Free;
  end;
end;

procedure TTestForm.HelpBtnClick(Sender: TObject);
begin
  with Application do begin
    HelpFile := ExtractFilePath(ExeName) + 'qi094.hlp';
    HelpCommand(HELP_CONTENTS, 0);
  end;
end;

procedure TTestForm.FontBtnClick(Sender: TObject);
begin
  with FontDlg do
    if Execute then begin
      TestForm.Font   := Font;
      DefineDlg.Font  := Font;
      SelectDlg.Font  := Font;
      FilterDlg.Font  := Font;
      GroupDlg.Font   := Font;
      AutoGrpDlg.Font := Font;
      OrderDlg.Font   := Font;
      ModifyDlg.Font  := Font;
      LookupDlg.Font  := Font;
      Archiver.Font   := Font;
      TablesDlg.Font  := Font;
      QueryWdw.GridFont := Font;
    end;
end;

{ TQITablesDialog gives the QueryInfo system a similar capability to the
  usualy query builder where the database and tables are chosen by the end-user
  at run-time rather than defined by the developer at design-time.

  The next couple of procedures allows the end-user to add (a restricted
  listing of) tables of their choice to FieldInfo's Tables list (all fields
  and joins added automatically) while maintaining transparent joining.}

procedure TTestForm.PickTablesBtnClick(Sender: TObject);
begin
  ShowMessage('This is a user interface dialog that imparts true ad hoc ' +
    'query ability where the user can choose any available (where not ' +
    'restricted) database and tables instead of them being predefined ' +
    'at design-time. The programmer must still attend to the join issue, ' +
    'ensuring that joins are valid and bridging join logic defined.');
  if TablesDlg.Execute then begin
    QueryWdw.DatabaseName := FieldInfo.DatabaseName;
    QueryInfoChange(nil);
    UpdateInfoChange(nil);
  end;
end;

procedure TTestForm.CheckTable(Sender: TObject; DB, T: string; var Veto: Boolean);
begin
  T := Uppercase(T);     {only allow these tables to be listed by TablesDlg -}
  Veto := (T <> 'CUSTOMER.DB') and (T <> 'ORDERS.DB') and (T <> 'ITEMS.DB') and
          (T <> 'PARTS.DB') and (T <> 'EMPLOYEE.DB') and (T <> 'VENDORS.DB');
end;

procedure TTestForm.CheckJoin(Sender: TObject; DB, T1, F1, T2, F2: string;
  var Veto: Boolean);   {handles TablesDlg's OnAddJoin event}
begin               {only accept "OrderNo", "CustNo", etc as join fields}
  Veto := Pos('No', F1) <> Length(F1) - 1;      {veto joins on 'City', etc}
end;

{ Something like this needs to be done for whatever database tables the end-user
  chooses to query on, eg as below, if Customers and Items are used in a query,
  the joins between Customers and Orders, and Items and Orders need to be
  included. The procedure below achieves this transparently to the user.

  table join links:      Vendors - Parts - Items - Orders - Customers
                                                      \ - Employees
}
procedure TTestForm.ForceBridgingJoins;
var
  Item, Part, Vendor, Order, Cust, Empl: TTableItem;
begin
  with QueryInfo do begin   {ensure bridging joins made where required -}
    Item   := Tables.BySQLName('Items');
    Part   := Tables.BySQLName('Parts');       {TQueryInfo gives access to the}
    Vendor := Tables.BySQLName('Vendors');     {Tables, Fields & Joins lists}
    Order  := Tables.BySQLName('Orders');      {of its connected FieldInfo}
    Cust   := Tables.BySQLName('Customer');
    Empl   := Tables.BySQLName('Employee');
    if Part <> nil then Part.Master :=                                   {A table item with its    }
      (TableUsed(Vendor) and TableUsed(Item))  or    {master property set will }
      (TableUsed(Vendor) and TableUsed(Order)) or    {always be included in    }
      (TableUsed(Vendor) and TableUsed(Cust))  or    {the FROM clause and its  }
      (TableUsed(Vendor) and TableUsed(Empl));       {common joins defined by  }
    if Item <> nil then Item.Master :=                                   {QIFormatter in the script}
      (TableUsed(Part)   and TableUsed(Order)) or
      (TableUsed(Part)   and TableUsed(Cust))  or
      (TableUsed(Part)   and TableUsed(Empl))  or
      (TableUsed(Vendor) and TableUsed(Order)) or
      (TableUsed(Vendor) and TableUsed(Cust))  or
      (TableUsed(Vendor) and TableUsed(Empl));
    if Order <> nil then Order.Master :=
      (TableUsed(Cust) and TableUsed(Item))   or
      (TableUsed(Cust) and TableUsed(Part))   or
      (TableUsed(Cust) and TableUsed(Vendor)) or
      (TableUsed(Cust) and TableUsed(Empl))   or
      (TableUsed(Empl) and TableUsed(Item))   or
      (TableUsed(Empl) and TableUsed(Part))   or
      (TableUsed(Empl) and TableUsed(Vendor));             {phew!}
  end;
end;

end.
